---
title: Element.getElementsByTagName()
slug: Web/API/Element/getElementsByTagName
tags:
  - API
  - DOM
  - Element
  - Method
  - Reference
---
<div>{{ APIRef("DOM") }}</div>

<p><span class="seoSummary">The <code><strong>Element.getElementsByTagName()</strong></code> method returns a live {{domxref("HTMLCollection")}} of elements with the given <a href="/en/DOM/element.tagName">tag name</a>.</span> All descendants of the specified element are searched, but not the element itself. The returned list is <em>live</em>, which means it updates itself with the DOM tree automatically. Therefore, there is no need to call <code>Element.getElementsByTagName()</code> with the same element and arguments repeatedly if the DOM changes in between calls.</p>

<p>When called on an HTML element in an HTML document, <code>getElementsByTagName</code> lower-cases the argument before searching for it. This is undesirable when trying to match camel-cased SVG elements (such as <code><a href="/en-US/docs/Web/SVG/Element/linearGradient">&lt;linearGradient&gt;</a></code>) in an HTML document. Instead, use {{ domxref("Element.getElementsByTagNameNS()") }}, which preserves the capitalization of the tag name.</p>

<p><code>Element.getElementsByTagName</code> is similar to {{domxref("Document.getElementsByTagName()")}}, except that it only searches for elements that are descendants of the specified element.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code><em>elements</em> = <em>element</em>.getElementsByTagName(<em>tagName</em>)</code></pre>

<ul>
	<li><code>elements</code> is a <em>live</em> {{domxref("HTMLCollection")}} of elements with a matching tag name, in the order they appear. If no elements are found, the <code>HTMLCollection</code> is empty.</li>
	<li><code>element</code> is the element from where the search starts. Only the element's descendants are included, not the element itself.</li>
	<li><code>tagName</code> is the qualified name to look for. The special string <code>"*"</code> represents all elements. For compatibility with XHTML, lower-case should be used.</li>
</ul>

<h2 id="Example">Example</h2>

<pre class="brush: js">// Check the status of each data cell in a table
const table = document.getElementById('forecast-table');
const cells = table.getElementsByTagName('td');

for (let cell of cells) {
  let status = cell.getAttribute('data-status');
  if (status === 'open') {
    // Grab the data
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#dom-element-getelementsbytagname', 'Element.getElementsByTagName()')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td>Changed the return value from {{domxref("NodeList")}} to {{domxref("HTMLCollection")}}</td>
		</tr>
		<tr>
			<td>{{SpecName('DOM3 Core', 'core.html#ID-1938918D', 'Element.getElementsByTagName()')}}</td>
			<td>{{Spec2('DOM3 Core')}}</td>
			<td>No change from {{SpecName('DOM2 Core')}}</td>
		</tr>
		<tr>
			<td>{{SpecName('DOM2 Core', 'core.html#ID-1938918D', 'Element.getElementsByTagName()')}}</td>
			<td>{{Spec2('DOM2 Core')}}</td>
			<td>No change from {{SpecName('DOM1')}}</td>
		</tr>
		<tr>
			<td>{{SpecName('DOM1', 'level-one-core.html#ID-1938918D', 'Element.getElementsByTagName()')}}</td>
			<td>{{Spec2('DOM1')}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.getElementsByTagName")}}</p>
